
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AddressesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const addresses = await db.addresses.create(
            {
                id: data.id || undefined,
        
        type: data.type
        ||
        null
            ,
            
        label: data.label
        ||
        null
            ,
            
        contact_name: data.contact_name
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
        line1: data.line1
        ||
        null
            ,
            
        line2: data.line2
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        state: data.state
        ||
        null
            ,
            
        postal_code: data.postal_code
        ||
        null
            ,
            
        country: data.country
        ||
        null
            ,
            
        is_default: data.is_default
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await addresses.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return addresses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const addressesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                type: item.type
            ||
            null
            ,
            
                label: item.label
            ||
            null
            ,
            
                contact_name: item.contact_name
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
                line1: item.line1
            ||
            null
            ,
            
                line2: item.line2
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                state: item.state
            ||
            null
            ,
            
                postal_code: item.postal_code
            ||
            null
            ,
            
                country: item.country
            ||
            null
            ,
            
                is_default: item.is_default
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const addresses = await db.addresses.bulkCreate(addressesData, { transaction });

        // For each item created, replace relation files
        

        return addresses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const addresses = await db.addresses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.type !== undefined) updatePayload.type = data.type;
        
        
        if (data.label !== undefined) updatePayload.label = data.label;
        
        
        if (data.contact_name !== undefined) updatePayload.contact_name = data.contact_name;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        if (data.line1 !== undefined) updatePayload.line1 = data.line1;
        
        
        if (data.line2 !== undefined) updatePayload.line2 = data.line2;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.state !== undefined) updatePayload.state = data.state;
        
        
        if (data.postal_code !== undefined) updatePayload.postal_code = data.postal_code;
        
        
        if (data.country !== undefined) updatePayload.country = data.country;
        
        
        if (data.is_default !== undefined) updatePayload.is_default = data.is_default;
        
        
        updatePayload.updatedById = currentUser.id;

        await addresses.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await addresses.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return addresses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const addresses = await db.addresses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of addresses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of addresses) {
                await record.destroy({transaction});
            }
        });


        return addresses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const addresses = await db.addresses.findByPk(id, options);

        await addresses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await addresses.destroy({
            transaction
        });

        return addresses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const addresses = await db.addresses.findOne(
            { where },
            { transaction },
        );

        if (!addresses) {
            return addresses;
        }

        const output = addresses.get({plain: true});

        
        
        
        
        
        
        
        
        output.customers_billing_address = await addresses.getCustomers_billing_address({
            transaction
        });
        
        output.customers_shipping_address = await addresses.getCustomers_shipping_address({
            transaction
        });
        
        
        output.suppliers_billing_address = await addresses.getSuppliers_billing_address({
            transaction
        });
        
        output.suppliers_shipping_address = await addresses.getSuppliers_shipping_address({
            transaction
        });
        
        
        
        
        
        
        
        output.warehouses_address = await addresses.getWarehouses_address({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.invoices_billing_address = await addresses.getInvoices_billing_address({
            transaction
        });
        
        
        
        
        
        output.organization = await addresses.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.label) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'label',
                        filter.label,
                    ),
                };
            }
            
            if (filter.contact_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'contact_name',
                        filter.contact_name,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            
            if (filter.line1) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'line1',
                        filter.line1,
                    ),
                };
            }
            
            if (filter.line2) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'line2',
                        filter.line2,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.state) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'state',
                        filter.state,
                    ),
                };
            }
            
            if (filter.postal_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'postal_code',
                        filter.postal_code,
                    ),
                };
            }
            
            if (filter.country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'country',
                        filter.country,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.type) {
                where = {
                    ...where,
                type: filter.type,
            };
            }
            
            if (filter.is_default) {
                where = {
                    ...where,
                is_default: filter.is_default,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.addresses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'addresses',
                        'label',
                        query,
                    ),
                ],
            };
        }

        const records = await db.addresses.findAll({
            attributes: [ 'id', 'label' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['label', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.label,
        }));
    }

    
};

